from damage import *

# -- some damage objects (Physical, Fire & Special)
class physical_damage (damage):
    def __init__ (self, d_dmg):
        damage.__init__ (self, 0, damage.PHYSICAL, d_dmg)
    
    def to_string (self):
        return "physical: (%i, %i)" % (self.Damage[0], self.Damage[1])

    def deal_damage (self, defender):
        pass
        
class fire_damage (damage):
    def __init__ (self, d_dmg):
        damage.__init__ (self, 0, damage.FIRE, d_dmg)
    
    def to_string (self):
        return "fire: (%i, %i)" % (self.Damage[0], self.Damage[1])

    def deal_damage (self, defender):
        pass
        
class multiply_physical_damage (damage):
    def __init__ (self, d_dmg):
        damage.__init__ (self, 1, damage.SPECIAL, d_dmg)
    
    def to_string (self):
        return "increase physical damage by a factor of %i" % self.Damage

    def merge (self, other):
         if self.Id == other.Id:
            self.Damage = other.Damage * self.Damage
            return 1
         else: return 0        

    def deal_damage (self, defender):
        pass
 
 
# -- some Damage Functions
def physical_1 ():
    return physical_damage ((1, 6))

def physical_2 ():
    return physical_damage ((2, 4))
    
def special ():
    return multiply_physical_damage (2)

def fire ():
    return fire_damage ((3, 10))
 
    
# -- some Damage Chains
chain = damage_chain (physical_1)
print "> physical (1, 6) -->\n", chain.to_string ()

chain.insert (damage_chain (physical_2))
print "> physical (1, 6) + (2, 4) -->\n", chain.to_string ()

chain.insert (damage_chain (special))
print "> physical (1, 6) + (2, 4), special (physical x 2) -->\n", chain.to_string ()

chain.insert (damage_chain (special))
print "> physical (1, 6) + (2, 4), special (physical x 2 x 2) -->\n", chain.to_string ()

chain = damage_chain (fire)
print "> fire (3, 10) -->\n", chain.to_string ()

chain.insert (damage_chain (physical_2))
print "> physical (2, 4), fire (3, 10) -->\n", chain.to_string ()
